from PIL import Image, ImageDraw
import numpy as np
import timeit

from find_sprite import find_sprites

background_color = (255,255,255)

def create_sprite_labels_image(srpite, label_map):
    """
        Draws the masks of the sprites at the exact same position that the sprites were in the original image.
        Returns an image of equal dimension (width and height) as the original image that was passed to the function
    """
    if len(background_color) == 4:
        color_mode, c = ('tuple(np.random.randint(256, size=3)) + (255,)', 3)
    else:
        color_mode, c = ('tuple(np.random.randint(256, size=3))', 2)
    print(background_color)
    color = {}
    color[0] = background_color
    zeros_array = np.zeros((*label_map.shape, c), dtype=int)
    label_map = np.expand_dims(label_map, axis=2)
    label_map = np.append(label_map, zeros_array, axis=2)

    coordinate = np.argwhere(np.all(label_map == [0, *[0]*c], axis=2))
    for x, y in coordinate:
        label_map[x][y] = color[0]

    for x in srpite.keys():
        color[x] = eval(color_mode)
        coordinate = np.argwhere(np.all(label_map == [x, *[0]*c], axis=2))
        for i, j in coordinate:
            label_map[i][j] = color[x]

    
    image = Image.fromarray(label_map.astype('uint8'))
    draw = ImageDraw.Draw(image)
    for x, y in srpite.items():
        draw.rectangle((y.top_left, y.bottom_right), outline=color[x])

    return image

def main():
    image = Image.open('data/metal_slug_sprite_sheet.png')
    sprites, label_map = find_sprites(image)
    sprite_label_image = create_sprite_labels_image(sprites, label_map)
    sprite_label_image.save('sprtie_label.png')
    print(timeit.timeit(stmt=lambda: create_sprite_labels_image(sprites, label_map), number=1))

if __name__ == '__main__':
    main()